unit MainUnit;

{$APPTYPE CONSOLE}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Spin, Grids, OleCtrls, isp3;

const
  MAXNODES = 15;
  BOUND_MAX = 100;

type
  TMainForm = class(TForm)
    TopPanel: TPanel;
    LNumNodes: TLabel;
    BRecompPositions: TButton;
    SENumNodes: TSpinEdit;
    SGMatrix: TStringGrid;
    Label1: TLabel;
    EServer: TEdit;
    EPort: TLabel;
    SEPort: TSpinEdit;
    Button1: TButton;
    Button2: TButton;
    procedure FormResize(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure SENumNodesExit(Sender: TObject);
    procedure SGMatrixSetEditText(Sender: TObject; ACol, ARow: Integer;
      const Value: String);
    procedure BRecompPositionsClick(Sender: TObject);
    procedure EServerExit(Sender: TObject);
    procedure SEPortExit(Sender: TObject);
  private
    NumNodes : integer;
    NodePositions : array[1..3] of array [1..MAXNODES] of integer;
    procedure Send;
  public
  end;

var
  MainForm: TMainForm;

implementation

{$R *.DFM}

procedure TMainForm.FormCreate(Sender: TObject);
begin
  SENumNodes.MaxValue := MAXNODES;
  NumNodes := 0;
  SENumNodesExit(Self);
  EServerExit(Self);
  SEPortExit(Self);
  BRecompPositionsClick(Self);
end;

procedure TMainForm.FormResize(Sender: TObject);
begin
  if Width < 800 then
    Width := 800;
  if Height < 300 then
    Height := 300;
end;

procedure TMainForm.SENumNodesExit(Sender: TObject);
var nn, r, c : integer;
begin
  nn := SENumNodes.Value;
  SGMatrix.ColCount := nn + 1;
  SGMatrix.RowCount := nn + 1;
  if SENUmNodes.Value > NumNodes then
  begin
    // labels - just redraw all
    for r := NumNodes+1 to nn do
      SGMatrix.Cells[0,r]:='R'+IntToStr(r);
    for c := NumNodes+1 to nn do
      SGMatrix.Cells[c,0]:='C'+IntToStr(c);
    // fill lower block
    for r := NumNodes+1 to nn do
      for c := 1 to nn do
        SGMatrix.Cells[c,r]:='0';
    // fill upper-right block
    for c := NumNodes+1 to nn do
      for r := 1 to NumNodes do
        SGMatrix.Cells[c,r]:='0';
  end;
  NumNodes := SENUmNodes.Value;
  Send;
end;

procedure TMainForm.SGMatrixSetEditText(Sender: TObject; ACol,
  ARow: Integer; const Value: String);
var
  v : integer;
begin
  if Length(SGMatrix.Cells[ACol,ARow]) = 0 then
    Exit;
  try
    v := StrToInt(SGMatrix.Cells[ACol,ARow]);
  except
    on EConvertError do
    begin
      v := 1;
    end;
  end;
  if ACol = ARow then
    v := 0
  else
    if v <> 0 then
      v := 1;
  SGMatrix.Cells[ACol,ARow] := IntToStr(v);
  SGMatrix.Cells[ARow,ACol] := IntToStr(v);
  Send;
end;

procedure TMainForm.EServerExit(Sender: TObject);
begin
  // Output.RemoteHost := EServer.Text;
end;

procedure TMainForm.SEPortExit(Sender: TObject);
begin
  // Output.RemotePort := SEPort.Value;
end;

procedure TMainForm.BRecompPositionsClick(Sender: TObject);
var
  i : integer;
begin
  for i := 1 to SENumNodes.Value do
  begin
    NodePositions[1][i] := random(BOUND_MAX * 2) - BOUND_MAX;
    NodePositions[2][i] := random(BOUND_MAX * 2) - BOUND_MAX;
    NodePositions[3][i] := random(BOUND_MAX * 2) - BOUND_MAX;
  end;
  Send;
end;

procedure TMainForm.Send;
var
  numnodes, i, r, c : integer;
begin
  numnodes := SENumNodes.Value;
  writeln('NODES ' + IntToStr(numnodes));
  for i := 1 to numnodes do
    writeln('NODE ' + IntToStr(i) +
      ' X ' + IntToStr(NodePositions[1][i]),
      ' Y ' + IntToStr(NodePositions[1][i]),
      ' Z ' + IntToStr(NodePositions[1][i]));
  for r := 1 to numnodes do
  begin
    for c := 1 to numnodes do
      write(SGMatrix.Cells[c,r] + ' ');
    writeln;
  end;
end;

end.
